/*Plugin Hitpoints
written by Sir D. (c) 30.07.2007

This plugin is made for Beginner Servers which 
announces hits immediately to the player.

If player dies, his damage stats will be
displayed to him.

If player is dead, he can write /hits in chat
to display his damage stats again.

Install:
- LogDeamon is needed!
- mp_logdetail 3
*/

#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE 131072
new STRING_VERSION[MAX_DATA_LENGTH] = "AM_2.50.60_0.8";

new g_DamagePlayers[MAX_PLAYERS][MAX_PLAYERS];

public plugin_init(){
	plugin_registerinfo("Hit Points","Displays Hitpoints",STRING_VERSION);
	plugin_registercmd("hit_injure", "hit_injure", ACCESS_CONSOLE);
	plugin_registercmd("hit_kill", "hit_kill", ACCESS_CONSOLE);
	plugin_registercmd("hit_world", "hit_world", ACCESS_CONSOLE);
	plugin_registercmd("say", "HandleSay", ACCESS_ALL,"/hits: displays your damage list");
	exec( "logd_reg 57 admin_command hit_kill" );
	exec( "logd_reg 58 admin_command hit_injure" );
	exec( "logd_reg 62 admin_command hit_world" );
	return PLUGIN_CONTINUE;
}

public hit_world(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new i;
	new j;
	new maxplayers=maxplayercount();
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(Data[6]=='S' || Data[0]=='G' || Data[8]=='R'){
		for(i=1;i<=maxplayers;i++){
			for(j=1;j<=maxplayers;j++){
				g_DamagePlayers[i][j]=0;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public hit_kill(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Attacker[MAX_NAME_LENGTH];
	new Victim[MAX_NAME_LENGTH];
	new Weapon[MAX_NAME_LENGTH];
	new sAID[3];
	new sVID[3];
	new iAID;
	new iVID;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strsep(Data," ",sAID,3,sVID,3,Weapon,MAX_NAME_LENGTH);
	iAID=strtonum(sAID);
	iVID=strtonum(sVID);
	if(playerinfo(iAID,Attacker,MAX_NAME_LENGTH)){
		if(playerinfo(iVID,Victim,MAX_NAME_LENGTH)){
			snprintf(Data,MAX_DATA_LENGTH,"^n^n^n^n^n^n^n^n^n^n^nYour Damage-Stats:");
			show_hits(iVID,Victim,Data);
		}
	}
	return PLUGIN_CONTINUE;
}
	
public hit_injure(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Dummy[MAX_DATA_LENGTH];
	new Weapon[MAX_NAME_LENGTH];
	new Attacker[MAX_NAME_LENGTH];
	new Victim[MAX_NAME_LENGTH];
	new sAttacker[3];
	new sVictim[3];
	new sDamage[4];
	new sHealth[4];
	new iAID;
	new iVID;
	new iDamage;
	new iTeamA;
	new iTeamB;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strsep(Data," ",sAttacker,3,sVictim,3,Weapon,MAX_NAME_LENGTH,Dummy,MAX_DATA_LENGTH);
	strsplit(Dummy,"#",sDamage,4,sDamage,4,sHealth,4);
	
	iAID=strtonum(sAttacker);
	iVID=strtonum(sVictim);
	iDamage=strtonum(sDamage);
	
	if(playerinfo(iAID,Attacker,MAX_NAME_LENGTH,_,_,iTeamA)){
		if(playerinfo(iVID,Victim,MAX_NAME_LENGTH,_,_,iTeamB)){
			if(iTeamA!=iTeamB){
				g_DamagePlayers[iAID][iVID]+=iDamage;
				snprintf(Data,MAX_TEXT_LENGTH,"^n^n^n^n^n^n^n^n^n^n^n)%i - %s(^n--------------------",iDamage,Victim);
				show_hits(iAID,Attacker,Data);
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new iDead;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(strcmp(Data,"/hits")==0){
		playerinfo(UserIndex,Player,MAX_NAME_LENGTH,_,_,_,iDead);
		if(iDead){
			snprintf(Data,MAX_DATA_LENGTH,"^n^n^n^n^n^n^n^n^n^n^nYour Damage-Stats:");
			show_hits(UserIndex,Player,Data);
		}
	}
	return PLUGIN_CONTINUE;
}

show_hits(iPlayer,PlayerName[],Data[]){
	new Victim[MAX_NAME_LENGTH];
	new i;
	new maxplayers=maxplayercount();
	for(i=1;i<=maxplayers;i++){
		if(i!=iPlayer && g_DamagePlayers[iPlayer][i]>0){
			playerinfo(i,Victim,MAX_NAME_LENGTH);
			snprintf(Data,MAX_DATA_LENGTH,"%s^n%i - %s",Data,g_DamagePlayers[iPlayer][i],Victim);
		}
	}
	centersayex(PlayerName,Data,3,0,255,10);
}